#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int n = 4;

double t[n][n];
double best_val;
vector<int> best_p;

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i, j;

    for (i = 0; i < n; i++)
        for (j = 0; j < n; j++)
            cin >> t[i][j];
    
    vector<int> p(n);
    for (i = 0; i < n; i++) p[i] = i;
    best_p = p; best_val = 10e10;
    while (1) {
        double val = 0;
        for (i = 0; i < n; i++) {
            val += t[i][p[i]];
        }
        if (val < best_val) {
            best_val = val;
            best_p = p;
        }

        if (!next_permutation(p.begin(), p.end())) break;
    }                          

    for (i = 0; i < n; i++)
        cout << best_p[i] + 1 << " ";
    cout << endl;

    fclose(stdin); fclose(stdout);
    return 0;   
}
